<?php
namespace PHPMaker2020\hostelmgr20;

/**
 * Page class
 */
class activity_edit extends activity
{

	// Page ID
	public $PageID = "edit";

	// Project ID
	public $ProjectID = "{9D95FE21-5D89-4075-ACEB-258B1CE35B16}";

	// Table name
	public $TableName = 'activity';

	// Page object name
	public $PageObjName = "activity_edit";

	// Page headings
	public $Heading = "";
	public $Subheading = "";
	public $PageHeader;
	public $PageFooter;

	// Token
	public $Token = "";
	public $TokenTimeout = 0;
	public $CheckToken;

	// Page heading
	public function pageHeading()
	{
		global $Language;
		if ($this->Heading != "")
			return $this->Heading;
		if (method_exists($this, "tableCaption"))
			return $this->tableCaption();
		return "";
	}

	// Page subheading
	public function pageSubheading()
	{
		global $Language;
		if ($this->Subheading != "")
			return $this->Subheading;
		if ($this->TableName)
			return $Language->phrase($this->PageID);
		return "";
	}

	// Page name
	public function pageName()
	{
		return CurrentPageName();
	}

	// Page URL
	public function pageUrl()
	{
		$url = CurrentPageName() . "?";
		if ($this->UseTokenInUrl)
			$url .= "t=" . $this->TableVar . "&"; // Add page token
		return $url;
	}

	// Messages
	private $_message = "";
	private $_failureMessage = "";
	private $_successMessage = "";
	private $_warningMessage = "";

	// Get message
	public function getMessage()
	{
		return isset($_SESSION[SESSION_MESSAGE]) ? $_SESSION[SESSION_MESSAGE] : $this->_message;
	}

	// Set message
	public function setMessage($v)
	{
		AddMessage($this->_message, $v);
		$_SESSION[SESSION_MESSAGE] = $this->_message;
	}

	// Get failure message
	public function getFailureMessage()
	{
		return isset($_SESSION[SESSION_FAILURE_MESSAGE]) ? $_SESSION[SESSION_FAILURE_MESSAGE] : $this->_failureMessage;
	}

	// Set failure message
	public function setFailureMessage($v)
	{
		AddMessage($this->_failureMessage, $v);
		$_SESSION[SESSION_FAILURE_MESSAGE] = $this->_failureMessage;
	}

	// Get success message
	public function getSuccessMessage()
	{
		return isset($_SESSION[SESSION_SUCCESS_MESSAGE]) ? $_SESSION[SESSION_SUCCESS_MESSAGE] : $this->_successMessage;
	}

	// Set success message
	public function setSuccessMessage($v)
	{
		AddMessage($this->_successMessage, $v);
		$_SESSION[SESSION_SUCCESS_MESSAGE] = $this->_successMessage;
	}

	// Get warning message
	public function getWarningMessage()
	{
		return isset($_SESSION[SESSION_WARNING_MESSAGE]) ? $_SESSION[SESSION_WARNING_MESSAGE] : $this->_warningMessage;
	}

	// Set warning message
	public function setWarningMessage($v)
	{
		AddMessage($this->_warningMessage, $v);
		$_SESSION[SESSION_WARNING_MESSAGE] = $this->_warningMessage;
	}

	// Clear message
	public function clearMessage()
	{
		$this->_message = "";
		$_SESSION[SESSION_MESSAGE] = "";
	}

	// Clear failure message
	public function clearFailureMessage()
	{
		$this->_failureMessage = "";
		$_SESSION[SESSION_FAILURE_MESSAGE] = "";
	}

	// Clear success message
	public function clearSuccessMessage()
	{
		$this->_successMessage = "";
		$_SESSION[SESSION_SUCCESS_MESSAGE] = "";
	}

	// Clear warning message
	public function clearWarningMessage()
	{
		$this->_warningMessage = "";
		$_SESSION[SESSION_WARNING_MESSAGE] = "";
	}

	// Clear messages
	public function clearMessages()
	{
		$this->clearMessage();
		$this->clearFailureMessage();
		$this->clearSuccessMessage();
		$this->clearWarningMessage();
	}

	// Show message
	public function showMessage()
	{
		$hidden = FALSE;
		$html = "";

		// Message
		$message = $this->getMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($message, "");
		if ($message != "") { // Message in Session, display
			if (!$hidden)
				$message = '<button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>' . $message;
			$html .= '<div class="alert alert-info alert-dismissible ew-info"><i class="icon fas fa-info"></i>' . $message . '</div>';
			$_SESSION[SESSION_MESSAGE] = ""; // Clear message in Session
		}

		// Warning message
		$warningMessage = $this->getWarningMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($warningMessage, "warning");
		if ($warningMessage != "") { // Message in Session, display
			if (!$hidden)
				$warningMessage = '<button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>' . $warningMessage;
			$html .= '<div class="alert alert-warning alert-dismissible ew-warning"><i class="icon fas fa-exclamation"></i>' . $warningMessage . '</div>';
			$_SESSION[SESSION_WARNING_MESSAGE] = ""; // Clear message in Session
		}

		// Success message
		$successMessage = $this->getSuccessMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($successMessage, "success");
		if ($successMessage != "") { // Message in Session, display
			if (!$hidden)
				$successMessage = '<button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>' . $successMessage;
			$html .= '<div class="alert alert-success alert-dismissible ew-success"><i class="icon fas fa-check"></i>' . $successMessage . '</div>';
			$_SESSION[SESSION_SUCCESS_MESSAGE] = ""; // Clear message in Session
		}

		// Failure message
		$errorMessage = $this->getFailureMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($errorMessage, "failure");
		if ($errorMessage != "") { // Message in Session, display
			if (!$hidden)
				$errorMessage = '<button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>' . $errorMessage;
			$html .= '<div class="alert alert-danger alert-dismissible ew-error"><i class="icon fas fa-ban"></i>' . $errorMessage . '</div>';
			$_SESSION[SESSION_FAILURE_MESSAGE] = ""; // Clear message in Session
		}
		echo '<div class="ew-message-dialog' . (($hidden) ? ' d-none' : "") . '">' . $html . '</div>';
	}

	// Get message as array
	public function getMessages()
	{
		$ar = [];

		// Message
		$message = $this->getMessage();

		//if (method_exists($this, "Message_Showing"))
		//	$this->Message_Showing($message, "");

		if ($message != "") { // Message in Session, display
			$ar["message"] = $message;
			$_SESSION[SESSION_MESSAGE] = ""; // Clear message in Session
		}

		// Warning message
		$warningMessage = $this->getWarningMessage();

		//if (method_exists($this, "Message_Showing"))
		//	$this->Message_Showing($warningMessage, "warning");

		if ($warningMessage != "") { // Message in Session, display
			$ar["warningMessage"] = $warningMessage;
			$_SESSION[SESSION_WARNING_MESSAGE] = ""; // Clear message in Session
		}

		// Success message
		$successMessage = $this->getSuccessMessage();

		//if (method_exists($this, "Message_Showing"))
		//	$this->Message_Showing($successMessage, "success");

		if ($successMessage != "") { // Message in Session, display
			$ar["successMessage"] = $successMessage;
			$_SESSION[SESSION_SUCCESS_MESSAGE] = ""; // Clear message in Session
		}

		// Failure message
		$failureMessage = $this->getFailureMessage();

		//if (method_exists($this, "Message_Showing"))
		//	$this->Message_Showing($failureMessage, "failure");

		if ($failureMessage != "") { // Message in Session, display
			$ar["failureMessage"] = $failureMessage;
			$_SESSION[SESSION_FAILURE_MESSAGE] = ""; // Clear message in Session
		}
		return $ar;
	}

	// Show Page Header
	public function showPageHeader()
	{
		$header = $this->PageHeader;
		$this->Page_DataRendering($header);
		if ($header != "") { // Header exists, display
			echo '<p id="ew-page-header">' . $header . '</p>';
		}
	}

	// Show Page Footer
	public function showPageFooter()
	{
		$footer = $this->PageFooter;
		$this->Page_DataRendered($footer);
		if ($footer != "") { // Footer exists, display
			echo '<p id="ew-page-footer">' . $footer . '</p>';
		}
	}

	// Validate page request
	protected function isPageRequest()
	{
		global $CurrentForm;
		if ($this->UseTokenInUrl) {
			if ($CurrentForm)
				return ($this->TableVar == $CurrentForm->getValue("t"));
			if (Get("t") !== NULL)
				return ($this->TableVar == Get("t"));
		}
		return TRUE;
	}

	// Valid Post
	protected function validPost()
	{
		if (!$this->CheckToken || !IsPost() || IsApi())
			return TRUE;
		if (Post(Config("TOKEN_NAME")) === NULL)
			return FALSE;
		$fn = Config("CHECK_TOKEN_FUNC");
		if (is_callable($fn))
			return $fn(Post(Config("TOKEN_NAME")), $this->TokenTimeout);
		return FALSE;
	}

	// Create Token
	public function createToken()
	{
		global $CurrentToken;
		$fn = Config("CREATE_TOKEN_FUNC"); // Always create token, required by API file/lookup request
		if ($this->Token == "" && is_callable($fn)) // Create token
			$this->Token = $fn();
		$CurrentToken = $this->Token; // Save to global variable
	}

	// Constructor
	public function __construct()
	{
		global $Language, $DashboardReport;
		global $UserTable;

		// Check token
		$this->CheckToken = Config("CHECK_TOKEN");

		// Initialize
		$GLOBALS["Page"] = &$this;
		$this->TokenTimeout = SessionTimeoutTime();

		// Language object
		if (!isset($Language))
			$Language = new Language();

		// Parent constuctor
		parent::__construct();

		// Table object (activity)
		if (!isset($GLOBALS["activity"]) || get_class($GLOBALS["activity"]) == PROJECT_NAMESPACE . "activity") {
			$GLOBALS["activity"] = &$this;
			$GLOBALS["Table"] = &$GLOBALS["activity"];
		}

		// Table object (staff)
		if (!isset($GLOBALS['staff']))
			$GLOBALS['staff'] = new staff();

		// Table object (admission)
		if (!isset($GLOBALS['admission']))
			$GLOBALS['admission'] = new admission();

		// Table object (indiscipline)
		if (!isset($GLOBALS['indiscipline']))
			$GLOBALS['indiscipline'] = new indiscipline();

		// Page ID (for backward compatibility only)
		if (!defined(PROJECT_NAMESPACE . "PAGE_ID"))
			define(PROJECT_NAMESPACE . "PAGE_ID", 'edit');

		// Table name (for backward compatibility only)
		if (!defined(PROJECT_NAMESPACE . "TABLE_NAME"))
			define(PROJECT_NAMESPACE . "TABLE_NAME", 'activity');

		// Start timer
		if (!isset($GLOBALS["DebugTimer"]))
			$GLOBALS["DebugTimer"] = new Timer();

		// Debug message
		LoadDebugMessage();

		// Open connection
		if (!isset($GLOBALS["Conn"]))
			$GLOBALS["Conn"] = $this->getConnection();

		// User table object (staff)
		$UserTable = $UserTable ?: new staff();
	}

	// Terminate page
	public function terminate($url = "")
	{
		global $ExportFileName, $TempImages, $DashboardReport;

		// Page Unload event
		$this->Page_Unload();

		// Global Page Unloaded event (in userfn*.php)
		Page_Unloaded();

		// Export
		global $activity;
		if ($this->CustomExport && $this->CustomExport == $this->Export && array_key_exists($this->CustomExport, Config("EXPORT_CLASSES"))) {
				$content = ob_get_contents();
			if ($ExportFileName == "")
				$ExportFileName = $this->TableVar;
			$class = PROJECT_NAMESPACE . Config("EXPORT_CLASSES." . $this->CustomExport);
			if (class_exists($class)) {
				$doc = new $class($activity);
				$doc->Text = @$content;
				if ($this->isExport("email"))
					echo $this->exportEmail($doc->Text);
				else
					$doc->export();
				DeleteTempImages(); // Delete temp images
				exit();
			}
		}
		if (!IsApi())
			$this->Page_Redirecting($url);

		// Close connection
		CloseConnections();

		// Return for API
		if (IsApi()) {
			$res = $url === TRUE;
			if (!$res) // Show error
				WriteJson(array_merge(["success" => FALSE], $this->getMessages()));
			return;
		}

		// Go to URL if specified
		if ($url != "") {
			if (!Config("DEBUG") && ob_get_length())
				ob_end_clean();

			// Handle modal response
			if ($this->IsModal) { // Show as modal
				$row = ["url" => $url, "modal" => "1"];
				$pageName = GetPageName($url);
				if ($pageName != $this->getListUrl()) { // Not List page
					$row["caption"] = $this->getModalCaption($pageName);
					if ($pageName == "activityview.php")
						$row["view"] = "1";
				} else { // List page should not be shown as modal => error
					$row["error"] = $this->getFailureMessage();
					$this->clearFailureMessage();
				}
				WriteJson($row);
			} else {
				SaveDebugMessage();
				AddHeader("Location", $url);
			}
		}
		exit();
	}

	// Get records from recordset
	protected function getRecordsFromRecordset($rs, $current = FALSE)
	{
		$rows = [];
		if (is_object($rs)) { // Recordset
			while ($rs && !$rs->EOF) {
				$this->loadRowValues($rs); // Set up DbValue/CurrentValue
				$row = $this->getRecordFromArray($rs->fields);
				if ($current)
					return $row;
				else
					$rows[] = $row;
				$rs->moveNext();
			}
		} elseif (is_array($rs)) {
			foreach ($rs as $ar) {
				$row = $this->getRecordFromArray($ar);
				if ($current)
					return $row;
				else
					$rows[] = $row;
			}
		}
		return $rows;
	}

	// Get record from array
	protected function getRecordFromArray($ar)
	{
		$row = [];
		if (is_array($ar)) {
			foreach ($ar as $fldname => $val) {
				if (array_key_exists($fldname, $this->fields) && ($this->fields[$fldname]->Visible || $this->fields[$fldname]->IsPrimaryKey)) { // Primary key or Visible
					$fld = &$this->fields[$fldname];
					if ($fld->HtmlTag == "FILE") { // Upload field
						if (EmptyValue($val)) {
							$row[$fldname] = NULL;
						} else {
							if ($fld->DataType == DATATYPE_BLOB) {
								$url = FullUrl(GetApiUrl(Config("API_FILE_ACTION"),
									Config("API_OBJECT_NAME") . "=" . $fld->TableVar . "&" .
									Config("API_FIELD_NAME") . "=" . $fld->Param . "&" .
									Config("API_KEY_NAME") . "=" . rawurlencode($this->getRecordKeyValue($ar)))); //*** need to add this? API may not be in the same folder
								$row[$fldname] = ["mimeType" => ContentType($val), "url" => $url];
							} elseif (!$fld->UploadMultiple || !ContainsString($val, Config("MULTIPLE_UPLOAD_SEPARATOR"))) { // Single file
								$row[$fldname] = ["mimeType" => MimeContentType($val), "url" => FullUrl($fld->hrefPath() . $val)];
							} else { // Multiple files
								$files = explode(Config("MULTIPLE_UPLOAD_SEPARATOR"), $val);
								$ar = [];
								foreach ($files as $file) {
									if (!EmptyValue($file))
										$ar[] = ["type" => MimeContentType($file), "url" => FullUrl($fld->hrefPath() . $file)];
								}
								$row[$fldname] = $ar;
							}
						}
					} else {
						$row[$fldname] = $val;
					}
				}
			}
		}
		return $row;
	}

	// Get record key value from array
	protected function getRecordKeyValue($ar)
	{
		$key = "";
		if (is_array($ar)) {
			$key .= @$ar['id'];
		}
		return $key;
	}

	/**
	 * Hide fields for add/edit
	 *
	 * @return void
	 */
	protected function hideFieldsForAddEdit()
	{
		if ($this->isAdd() || $this->isCopy() || $this->isGridAdd())
			$this->id->Visible = FALSE;
	}

	// Lookup data
	public function lookup()
	{
		global $Language, $Security;
		if (!isset($Language))
			$Language = new Language(Config("LANGUAGE_FOLDER"), Post("language", ""));

		// Set up API request
		if (!$this->setupApiRequest())
			return FALSE;

		// Get lookup object
		$fieldName = Post("field");
		if (!array_key_exists($fieldName, $this->fields))
			return FALSE;
		$lookupField = $this->fields[$fieldName];
		$lookup = $lookupField->Lookup;
		if ($lookup === NULL)
			return FALSE;
		$tbl = $lookup->getTable();
		if (!$Security->allowLookup(Config("PROJECT_ID") . $tbl->TableName)) // Lookup permission
			return FALSE;

		// Get lookup parameters
		$lookupType = Post("ajax", "unknown");
		$pageSize = -1;
		$offset = -1;
		$searchValue = "";
		if (SameText($lookupType, "modal")) {
			$searchValue = Post("sv", "");
			$pageSize = Post("recperpage", 10);
			$offset = Post("start", 0);
		} elseif (SameText($lookupType, "autosuggest")) {
			$searchValue = Get("q", "");
			$pageSize = Param("n", -1);
			$pageSize = is_numeric($pageSize) ? (int)$pageSize : -1;
			if ($pageSize <= 0)
				$pageSize = Config("AUTO_SUGGEST_MAX_ENTRIES");
			$start = Param("start", -1);
			$start = is_numeric($start) ? (int)$start : -1;
			$page = Param("page", -1);
			$page = is_numeric($page) ? (int)$page : -1;
			$offset = $start >= 0 ? $start : ($page > 0 && $pageSize > 0 ? ($page - 1) * $pageSize : 0);
		}
		$userSelect = Decrypt(Post("s", ""));
		$userFilter = Decrypt(Post("f", ""));
		$userOrderBy = Decrypt(Post("o", ""));
		$keys = Post("keys");
		$lookup->LookupType = $lookupType; // Lookup type
		if ($keys !== NULL) { // Selected records from modal
			if (is_array($keys))
				$keys = implode(Config("MULTIPLE_OPTION_SEPARATOR"), $keys);
			$lookup->FilterFields = []; // Skip parent fields if any
			$lookup->FilterValues[] = $keys; // Lookup values
			$pageSize = -1; // Show all records
		} else { // Lookup values
			$lookup->FilterValues[] = Post("v0", Post("lookupValue", ""));
		}
		$cnt = is_array($lookup->FilterFields) ? count($lookup->FilterFields) : 0;
		for ($i = 1; $i <= $cnt; $i++)
			$lookup->FilterValues[] = Post("v" . $i, "");
		$lookup->SearchValue = $searchValue;
		$lookup->PageSize = $pageSize;
		$lookup->Offset = $offset;
		if ($userSelect != "")
			$lookup->UserSelect = $userSelect;
		if ($userFilter != "")
			$lookup->UserFilter = $userFilter;
		if ($userOrderBy != "")
			$lookup->UserOrderBy = $userOrderBy;
		$lookup->toJson($this); // Use settings from current page
	}

	// Set up API request
	public function setupApiRequest()
	{
		global $Security;

		// Check security for API request
		If (ValidApiRequest()) {
			if ($Security->isLoggedIn()) $Security->TablePermission_Loading();
			$Security->loadCurrentUserLevel(Config("PROJECT_ID") . $this->TableName);
			if ($Security->isLoggedIn()) $Security->TablePermission_Loaded();
			return TRUE;
		}
		return FALSE;
	}
	public $FormClassName = "ew-horizontal ew-form ew-edit-form";
	public $IsModal = FALSE;
	public $IsMobileOrModal = FALSE;
	public $DbMasterFilter;
	public $DbDetailFilter;

	//
	// Page run
	//

	public function run()
	{
		global $ExportType, $CustomExportType, $ExportFileName, $UserProfile, $Language, $Security, $CurrentForm,
			$FormError, $SkipHeaderFooter;

		// Is modal
		$this->IsModal = (Param("modal") == "1");

		// User profile
		$UserProfile = new UserProfile();

		// Security
		if (!$this->setupApiRequest()) {
			$Security = new AdvancedSecurity();
			if (!$Security->isLoggedIn())
				$Security->autoLogin();
			if ($Security->isLoggedIn())
				$Security->TablePermission_Loading();
			$Security->loadCurrentUserLevel($this->ProjectID . $this->TableName);
			if ($Security->isLoggedIn())
				$Security->TablePermission_Loaded();
			if (!$Security->canEdit()) {
				$Security->saveLastUrl();
				$this->setFailureMessage(DeniedMessage()); // Set no permission
				if ($Security->canList())
					$this->terminate(GetUrl("activitylist.php"));
				else
					$this->terminate(GetUrl("login.php"));
				return;
			}
		}

		// Create form object
		$CurrentForm = new HttpForm();
		$this->CurrentAction = Param("action"); // Set up current action
		$this->id->setVisibility();
		$this->HotelID->setVisibility();
		$this->RollNo->setVisibility();
		$this->Name->setVisibility();
		$this->Hostel->setVisibility();
		$this->Floor->setVisibility();
		$this->Room_No->setVisibility();
		$this->Health_issue->setVisibility();
		$this->Indiscipline_activity->setVisibility();
		$this->Involvement->setVisibility();
		$this->Remarks->setVisibility();
		$this->Others->setVisibility();
		$this->Updatedby->setVisibility();
		$this->Updated_Date->setVisibility();
		$this->hideFieldsForAddEdit();

		// Do not use lookup cache
		$this->setUseLookupCache(FALSE);

		// Global Page Loading event (in userfn*.php)
		Page_Loading();

		// Page Load event
		$this->Page_Load();

		// Check token
		if (!$this->validPost()) {
			Write($Language->phrase("InvalidPostRequest"));
			$this->terminate();
		}

		// Create Token
		$this->createToken();

		// Set up lookup cache
		$this->setupLookupOptions($this->Hostel);
		$this->setupLookupOptions($this->Floor);
		$this->setupLookupOptions($this->Room_No);
		$this->setupLookupOptions($this->Health_issue);
		$this->setupLookupOptions($this->Indiscipline_activity);
		$this->setupLookupOptions($this->Involvement);

		// Check modal
		if ($this->IsModal)
			$SkipHeaderFooter = TRUE;
		$this->IsMobileOrModal = IsMobile() || $this->IsModal;
		$this->FormClassName = "ew-form ew-edit-form ew-horizontal";
		$loaded = FALSE;
		$postBack = FALSE;

		// Set up current action and primary key
		if (IsApi()) {
			$this->CurrentAction = "update"; // Update record directly
			$postBack = TRUE;
		} elseif (Post("action") !== NULL) {
			$this->CurrentAction = Post("action"); // Get action code
			if (!$this->isShow()) // Not reload record, handle as postback
				$postBack = TRUE;

			// Load key from Form
			if ($CurrentForm->hasValue("x_id")) {
				$this->id->setFormValue($CurrentForm->getValue("x_id"));
			}
		} else {
			$this->CurrentAction = "show"; // Default action is display

			// Load key from QueryString
			$loadByQuery = FALSE;
			if (Get("id") !== NULL) {
				$this->id->setQueryStringValue(Get("id"));
				$loadByQuery = TRUE;
			} else {
				$this->id->CurrentValue = NULL;
			}
		}

		// Set up master detail parameters
		$this->setupMasterParms();

		// Load current record
		$loaded = $this->loadRow();

		// Process form if post back
		if ($postBack) {
			$this->loadFormValues(); // Get form values
		}

		// Validate form if post back
		if ($postBack) {
			if (!$this->validateForm()) {
				$this->setFailureMessage($FormError);
				$this->EventCancelled = TRUE; // Event cancelled
				$this->restoreFormValues();
				if (IsApi()) {
					$this->terminate();
					return;
				} else {
					$this->CurrentAction = ""; // Form error, reset action
				}
			}
		}

		// Perform current action
		switch ($this->CurrentAction) {
			case "show": // Get a record to display
				if (!$loaded) { // Load record based on key
					if ($this->getFailureMessage() == "")
						$this->setFailureMessage($Language->phrase("NoRecord")); // No record found
					$this->terminate("activitylist.php"); // No matching record, return to list
				}
				break;
			case "update": // Update
				$returnUrl = $this->getReturnUrl();
				if (GetPageName($returnUrl) == "activitylist.php")
					$returnUrl = $this->addMasterUrl($returnUrl); // List page, return to List page with correct master key if necessary
				$this->SendEmail = TRUE; // Send email on update success
				if ($this->editRow()) { // Update record based on key
					if ($this->getSuccessMessage() == "")
						$this->setSuccessMessage($Language->phrase("UpdateSuccess")); // Update success
					if (IsApi()) {
						$this->terminate(TRUE);
						return;
					} else {
						$this->terminate($returnUrl); // Return to caller
					}
				} elseif (IsApi()) { // API request, return
					$this->terminate();
					return;
				} elseif ($this->getFailureMessage() == $Language->phrase("NoRecord")) {
					$this->terminate($returnUrl); // Return to caller
				} else {
					$this->EventCancelled = TRUE; // Event cancelled
					$this->restoreFormValues(); // Restore form values if update failed
				}
		}

		// Set up Breadcrumb
		$this->setupBreadcrumb();

		// Render the record
		$this->RowType = ROWTYPE_EDIT; // Render as Edit
		$this->resetAttributes();
		$this->renderRow();
	}

	// Get upload files
	protected function getUploadFiles()
	{
		global $CurrentForm, $Language;
	}

	// Load form values
	protected function loadFormValues()
	{

		// Load from form
		global $CurrentForm;

		// Check field name 'id' first before field var 'x_id'
		$val = $CurrentForm->hasValue("id") ? $CurrentForm->getValue("id") : $CurrentForm->getValue("x_id");
		if (!$this->id->IsDetailKey)
			$this->id->setFormValue($val);

		// Check field name 'HotelID' first before field var 'x_HotelID'
		$val = $CurrentForm->hasValue("HotelID") ? $CurrentForm->getValue("HotelID") : $CurrentForm->getValue("x_HotelID");
		if (!$this->HotelID->IsDetailKey) {
			if (IsApi() && $val == NULL)
				$this->HotelID->Visible = FALSE; // Disable update for API request
			else
				$this->HotelID->setFormValue($val);
		}

		// Check field name 'RollNo' first before field var 'x_RollNo'
		$val = $CurrentForm->hasValue("RollNo") ? $CurrentForm->getValue("RollNo") : $CurrentForm->getValue("x_RollNo");
		if (!$this->RollNo->IsDetailKey) {
			if (IsApi() && $val == NULL)
				$this->RollNo->Visible = FALSE; // Disable update for API request
			else
				$this->RollNo->setFormValue($val);
		}

		// Check field name 'Name' first before field var 'x_Name'
		$val = $CurrentForm->hasValue("Name") ? $CurrentForm->getValue("Name") : $CurrentForm->getValue("x_Name");
		if (!$this->Name->IsDetailKey) {
			if (IsApi() && $val == NULL)
				$this->Name->Visible = FALSE; // Disable update for API request
			else
				$this->Name->setFormValue($val);
		}

		// Check field name 'Hostel' first before field var 'x_Hostel'
		$val = $CurrentForm->hasValue("Hostel") ? $CurrentForm->getValue("Hostel") : $CurrentForm->getValue("x_Hostel");
		if (!$this->Hostel->IsDetailKey) {
			if (IsApi() && $val == NULL)
				$this->Hostel->Visible = FALSE; // Disable update for API request
			else
				$this->Hostel->setFormValue($val);
		}

		// Check field name 'Floor' first before field var 'x_Floor'
		$val = $CurrentForm->hasValue("Floor") ? $CurrentForm->getValue("Floor") : $CurrentForm->getValue("x_Floor");
		if (!$this->Floor->IsDetailKey) {
			if (IsApi() && $val == NULL)
				$this->Floor->Visible = FALSE; // Disable update for API request
			else
				$this->Floor->setFormValue($val);
		}

		// Check field name 'Room_No' first before field var 'x_Room_No'
		$val = $CurrentForm->hasValue("Room_No") ? $CurrentForm->getValue("Room_No") : $CurrentForm->getValue("x_Room_No");
		if (!$this->Room_No->IsDetailKey) {
			if (IsApi() && $val == NULL)
				$this->Room_No->Visible = FALSE; // Disable update for API request
			else
				$this->Room_No->setFormValue($val);
		}

		// Check field name 'Health_issue' first before field var 'x_Health_issue'
		$val = $CurrentForm->hasValue("Health_issue") ? $CurrentForm->getValue("Health_issue") : $CurrentForm->getValue("x_Health_issue");
		if (!$this->Health_issue->IsDetailKey) {
			if (IsApi() && $val == NULL)
				$this->Health_issue->Visible = FALSE; // Disable update for API request
			else
				$this->Health_issue->setFormValue($val);
		}

		// Check field name 'Indiscipline_activity' first before field var 'x_Indiscipline_activity'
		$val = $CurrentForm->hasValue("Indiscipline_activity") ? $CurrentForm->getValue("Indiscipline_activity") : $CurrentForm->getValue("x_Indiscipline_activity");
		if (!$this->Indiscipline_activity->IsDetailKey) {
			if (IsApi() && $val == NULL)
				$this->Indiscipline_activity->Visible = FALSE; // Disable update for API request
			else
				$this->Indiscipline_activity->setFormValue($val);
		}

		// Check field name 'Involvement' first before field var 'x_Involvement'
		$val = $CurrentForm->hasValue("Involvement") ? $CurrentForm->getValue("Involvement") : $CurrentForm->getValue("x_Involvement");
		if (!$this->Involvement->IsDetailKey) {
			if (IsApi() && $val == NULL)
				$this->Involvement->Visible = FALSE; // Disable update for API request
			else
				$this->Involvement->setFormValue($val);
		}

		// Check field name 'Remarks' first before field var 'x_Remarks'
		$val = $CurrentForm->hasValue("Remarks") ? $CurrentForm->getValue("Remarks") : $CurrentForm->getValue("x_Remarks");
		if (!$this->Remarks->IsDetailKey) {
			if (IsApi() && $val == NULL)
				$this->Remarks->Visible = FALSE; // Disable update for API request
			else
				$this->Remarks->setFormValue($val);
		}

		// Check field name 'Others' first before field var 'x_Others'
		$val = $CurrentForm->hasValue("Others") ? $CurrentForm->getValue("Others") : $CurrentForm->getValue("x_Others");
		if (!$this->Others->IsDetailKey) {
			if (IsApi() && $val == NULL)
				$this->Others->Visible = FALSE; // Disable update for API request
			else
				$this->Others->setFormValue($val);
		}

		// Check field name 'Updatedby' first before field var 'x_Updatedby'
		$val = $CurrentForm->hasValue("Updatedby") ? $CurrentForm->getValue("Updatedby") : $CurrentForm->getValue("x_Updatedby");
		if (!$this->Updatedby->IsDetailKey) {
			if (IsApi() && $val == NULL)
				$this->Updatedby->Visible = FALSE; // Disable update for API request
			else
				$this->Updatedby->setFormValue($val);
		}

		// Check field name 'Updated_Date' first before field var 'x_Updated_Date'
		$val = $CurrentForm->hasValue("Updated_Date") ? $CurrentForm->getValue("Updated_Date") : $CurrentForm->getValue("x_Updated_Date");
		if (!$this->Updated_Date->IsDetailKey) {
			if (IsApi() && $val == NULL)
				$this->Updated_Date->Visible = FALSE; // Disable update for API request
			else
				$this->Updated_Date->setFormValue($val);
			$this->Updated_Date->CurrentValue = UnFormatDateTime($this->Updated_Date->CurrentValue, 0);
		}
	}

	// Restore form values
	public function restoreFormValues()
	{
		global $CurrentForm;
		$this->id->CurrentValue = $this->id->FormValue;
		$this->HotelID->CurrentValue = $this->HotelID->FormValue;
		$this->RollNo->CurrentValue = $this->RollNo->FormValue;
		$this->Name->CurrentValue = $this->Name->FormValue;
		$this->Hostel->CurrentValue = $this->Hostel->FormValue;
		$this->Floor->CurrentValue = $this->Floor->FormValue;
		$this->Room_No->CurrentValue = $this->Room_No->FormValue;
		$this->Health_issue->CurrentValue = $this->Health_issue->FormValue;
		$this->Indiscipline_activity->CurrentValue = $this->Indiscipline_activity->FormValue;
		$this->Involvement->CurrentValue = $this->Involvement->FormValue;
		$this->Remarks->CurrentValue = $this->Remarks->FormValue;
		$this->Others->CurrentValue = $this->Others->FormValue;
		$this->Updatedby->CurrentValue = $this->Updatedby->FormValue;
		$this->Updated_Date->CurrentValue = $this->Updated_Date->FormValue;
		$this->Updated_Date->CurrentValue = UnFormatDateTime($this->Updated_Date->CurrentValue, 0);
	}

	// Load row based on key values
	public function loadRow()
	{
		global $Security, $Language;
		$filter = $this->getRecordFilter();

		// Call Row Selecting event
		$this->Row_Selecting($filter);

		// Load SQL based on filter
		$this->CurrentFilter = $filter;
		$sql = $this->getCurrentSql();
		$conn = $this->getConnection();
		$res = FALSE;
		$rs = LoadRecordset($sql, $conn);
		if ($rs && !$rs->EOF) {
			$res = TRUE;
			$this->loadRowValues($rs); // Load row values
			$rs->close();
		}
		return $res;
	}

	// Load row values from recordset
	public function loadRowValues($rs = NULL)
	{
		if ($rs && !$rs->EOF)
			$row = $rs->fields;
		else
			$row = $this->newRow();

		// Call Row Selected event
		$this->Row_Selected($row);
		if (!$rs || $rs->EOF)
			return;
		$this->id->setDbValue($row['id']);
		$this->HotelID->setDbValue($row['HotelID']);
		$this->RollNo->setDbValue($row['RollNo']);
		$this->Name->setDbValue($row['Name']);
		$this->Hostel->setDbValue($row['Hostel']);
		$this->Floor->setDbValue($row['Floor']);
		$this->Room_No->setDbValue($row['Room_No']);
		$this->Health_issue->setDbValue($row['Health_issue']);
		$this->Indiscipline_activity->setDbValue($row['Indiscipline_activity']);
		$this->Involvement->setDbValue($row['Involvement']);
		$this->Remarks->setDbValue($row['Remarks']);
		$this->Others->setDbValue($row['Others']);
		$this->Updatedby->setDbValue($row['Updatedby']);
		$this->Updated_Date->setDbValue($row['Updated_Date']);
	}

	// Return a row with default values
	protected function newRow()
	{
		$row = [];
		$row['id'] = NULL;
		$row['HotelID'] = NULL;
		$row['RollNo'] = NULL;
		$row['Name'] = NULL;
		$row['Hostel'] = NULL;
		$row['Floor'] = NULL;
		$row['Room_No'] = NULL;
		$row['Health_issue'] = NULL;
		$row['Indiscipline_activity'] = NULL;
		$row['Involvement'] = NULL;
		$row['Remarks'] = NULL;
		$row['Others'] = NULL;
		$row['Updatedby'] = NULL;
		$row['Updated_Date'] = NULL;
		return $row;
	}

	// Load old record
	protected function loadOldRecord()
	{

		// Load key values from Session
		$validKey = TRUE;
		if (strval($this->getKey("id")) != "")
			$this->id->OldValue = $this->getKey("id"); // id
		else
			$validKey = FALSE;

		// Load old record
		$this->OldRecordset = NULL;
		if ($validKey) {
			$this->CurrentFilter = $this->getRecordFilter();
			$sql = $this->getCurrentSql();
			$conn = $this->getConnection();
			$this->OldRecordset = LoadRecordset($sql, $conn);
		}
		$this->loadRowValues($this->OldRecordset); // Load row values
		return $validKey;
	}

	// Render row values based on field settings
	public function renderRow()
	{
		global $Security, $Language, $CurrentLanguage;

		// Initialize URLs
		// Call Row_Rendering event

		$this->Row_Rendering();

		// Common render codes for all row types
		// id
		// HotelID
		// RollNo
		// Name
		// Hostel
		// Floor
		// Room_No
		// Health_issue
		// Indiscipline_activity
		// Involvement
		// Remarks
		// Others
		// Updatedby
		// Updated_Date

		if ($this->RowType == ROWTYPE_VIEW) { // View row

			// id
			$this->id->ViewValue = $this->id->CurrentValue;
			$this->id->ViewCustomAttributes = "";

			// HotelID
			$this->HotelID->ViewValue = $this->HotelID->CurrentValue;
			$this->HotelID->ViewCustomAttributes = "";

			// RollNo
			$this->RollNo->ViewValue = $this->RollNo->CurrentValue;
			$this->RollNo->ViewCustomAttributes = "";

			// Name
			$this->Name->ViewValue = $this->Name->CurrentValue;
			$this->Name->ViewCustomAttributes = "";

			// Hostel
			$curVal = strval($this->Hostel->CurrentValue);
			if ($curVal != "") {
				$this->Hostel->ViewValue = $this->Hostel->lookupCacheOption($curVal);
				if ($this->Hostel->ViewValue === NULL) { // Lookup from database
					$filterWrk = "`id`" . SearchString("=", $curVal, DATATYPE_NUMBER, "");
					$sqlWrk = $this->Hostel->Lookup->getSql(FALSE, $filterWrk, '', $this);
					$rswrk = Conn()->execute($sqlWrk);
					if ($rswrk && !$rswrk->EOF) { // Lookup values found
						$arwrk = [];
						$arwrk[1] = $rswrk->fields('df');
						$this->Hostel->ViewValue = $this->Hostel->displayValue($arwrk);
						$rswrk->Close();
					} else {
						$this->Hostel->ViewValue = $this->Hostel->CurrentValue;
					}
				}
			} else {
				$this->Hostel->ViewValue = NULL;
			}
			$this->Hostel->ViewCustomAttributes = "";

			// Floor
			$curVal = strval($this->Floor->CurrentValue);
			if ($curVal != "") {
				$this->Floor->ViewValue = $this->Floor->lookupCacheOption($curVal);
				if ($this->Floor->ViewValue === NULL) { // Lookup from database
					$filterWrk = "`id`" . SearchString("=", $curVal, DATATYPE_NUMBER, "");
					$sqlWrk = $this->Floor->Lookup->getSql(FALSE, $filterWrk, '', $this);
					$rswrk = Conn()->execute($sqlWrk);
					if ($rswrk && !$rswrk->EOF) { // Lookup values found
						$arwrk = [];
						$arwrk[1] = $rswrk->fields('df');
						$this->Floor->ViewValue = $this->Floor->displayValue($arwrk);
						$rswrk->Close();
					} else {
						$this->Floor->ViewValue = $this->Floor->CurrentValue;
					}
				}
			} else {
				$this->Floor->ViewValue = NULL;
			}
			$this->Floor->ViewCustomAttributes = "";

			// Room_No
			$curVal = strval($this->Room_No->CurrentValue);
			if ($curVal != "") {
				$this->Room_No->ViewValue = $this->Room_No->lookupCacheOption($curVal);
				if ($this->Room_No->ViewValue === NULL) { // Lookup from database
					$filterWrk = "`Room_No`" . SearchString("=", $curVal, DATATYPE_NUMBER, "");
					$sqlWrk = $this->Room_No->Lookup->getSql(FALSE, $filterWrk, '', $this);
					$rswrk = Conn()->execute($sqlWrk);
					if ($rswrk && !$rswrk->EOF) { // Lookup values found
						$arwrk = [];
						$arwrk[1] = FormatNumber($rswrk->fields('df'), 0, -2, -2, -2);
						$this->Room_No->ViewValue = $this->Room_No->displayValue($arwrk);
						$rswrk->Close();
					} else {
						$this->Room_No->ViewValue = $this->Room_No->CurrentValue;
					}
				}
			} else {
				$this->Room_No->ViewValue = NULL;
			}
			$this->Room_No->ViewCustomAttributes = "";

			// Health_issue
			$curVal = strval($this->Health_issue->CurrentValue);
			if ($curVal != "") {
				$this->Health_issue->ViewValue = $this->Health_issue->lookupCacheOption($curVal);
				if ($this->Health_issue->ViewValue === NULL) { // Lookup from database
					$arwrk = explode(",", $curVal);
					$filterWrk = "";
					foreach ($arwrk as $wrk) {
						if ($filterWrk != "")
							$filterWrk .= " OR ";
						$filterWrk .= "`Health_Issue`" . SearchString("=", trim($wrk), DATATYPE_STRING, "");
					}
					$lookupFilter = function() {
						return "`Status`='1'";
					};
					$lookupFilter = $lookupFilter->bindTo($this);
					$sqlWrk = $this->Health_issue->Lookup->getSql(FALSE, $filterWrk, $lookupFilter, $this);
					$rswrk = Conn()->execute($sqlWrk);
					if ($rswrk && !$rswrk->EOF) { // Lookup values found
						$this->Health_issue->ViewValue = new OptionValues();
						$ari = 0;
						while (!$rswrk->EOF) {
							$arwrk = [];
							$arwrk[1] = $rswrk->fields('df');
							$this->Health_issue->ViewValue->add($this->Health_issue->displayValue($arwrk));
							$rswrk->MoveNext();
							$ari++;
						}
						$rswrk->Close();
					} else {
						$this->Health_issue->ViewValue = $this->Health_issue->CurrentValue;
					}
				}
			} else {
				$this->Health_issue->ViewValue = NULL;
			}
			$this->Health_issue->ViewCustomAttributes = "";

			// Indiscipline_activity
			$curVal = strval($this->Indiscipline_activity->CurrentValue);
			if ($curVal != "") {
				$this->Indiscipline_activity->ViewValue = $this->Indiscipline_activity->lookupCacheOption($curVal);
				if ($this->Indiscipline_activity->ViewValue === NULL) { // Lookup from database
					$arwrk = explode(",", $curVal);
					$filterWrk = "";
					foreach ($arwrk as $wrk) {
						if ($filterWrk != "")
							$filterWrk .= " OR ";
						$filterWrk .= "`id`" . SearchString("=", trim($wrk), DATATYPE_NUMBER, "");
					}
					$lookupFilter = function() {
						return "`Status`='1'";
					};
					$lookupFilter = $lookupFilter->bindTo($this);
					$sqlWrk = $this->Indiscipline_activity->Lookup->getSql(FALSE, $filterWrk, $lookupFilter, $this);
					$rswrk = Conn()->execute($sqlWrk);
					if ($rswrk && !$rswrk->EOF) { // Lookup values found
						$this->Indiscipline_activity->ViewValue = new OptionValues();
						$ari = 0;
						while (!$rswrk->EOF) {
							$arwrk = [];
							$arwrk[1] = $rswrk->fields('df');
							$this->Indiscipline_activity->ViewValue->add($this->Indiscipline_activity->displayValue($arwrk));
							$rswrk->MoveNext();
							$ari++;
						}
						$rswrk->Close();
					} else {
						$this->Indiscipline_activity->ViewValue = $this->Indiscipline_activity->CurrentValue;
					}
				}
			} else {
				$this->Indiscipline_activity->ViewValue = NULL;
			}
			$this->Indiscipline_activity->ViewCustomAttributes = "";

			// Involvement
			$curVal = strval($this->Involvement->CurrentValue);
			if ($curVal != "") {
				$this->Involvement->ViewValue = $this->Involvement->lookupCacheOption($curVal);
				if ($this->Involvement->ViewValue === NULL) { // Lookup from database
					$filterWrk = "`id`" . SearchString("=", $curVal, DATATYPE_NUMBER, "");
					$lookupFilter = function() {
						return "`Status`='1'";
					};
					$lookupFilter = $lookupFilter->bindTo($this);
					$sqlWrk = $this->Involvement->Lookup->getSql(FALSE, $filterWrk, $lookupFilter, $this);
					$rswrk = Conn()->execute($sqlWrk);
					if ($rswrk && !$rswrk->EOF) { // Lookup values found
						$arwrk = [];
						$arwrk[1] = $rswrk->fields('df');
						$this->Involvement->ViewValue = $this->Involvement->displayValue($arwrk);
						$rswrk->Close();
					} else {
						$this->Involvement->ViewValue = $this->Involvement->CurrentValue;
					}
				}
			} else {
				$this->Involvement->ViewValue = NULL;
			}
			$this->Involvement->ViewCustomAttributes = "";

			// Remarks
			$this->Remarks->ViewValue = $this->Remarks->CurrentValue;
			$this->Remarks->ViewCustomAttributes = "";

			// Others
			$this->Others->ViewValue = $this->Others->CurrentValue;
			$this->Others->ViewCustomAttributes = "";

			// Updatedby
			$this->Updatedby->ViewValue = $this->Updatedby->CurrentValue;
			$this->Updatedby->ViewCustomAttributes = "";

			// Updated_Date
			$this->Updated_Date->ViewValue = $this->Updated_Date->CurrentValue;
			$this->Updated_Date->ViewValue = FormatDateTime($this->Updated_Date->ViewValue, 0);
			$this->Updated_Date->ViewCustomAttributes = "";

			// id
			$this->id->LinkCustomAttributes = "";
			$this->id->HrefValue = "";
			$this->id->TooltipValue = "";

			// HotelID
			$this->HotelID->LinkCustomAttributes = "";
			$this->HotelID->HrefValue = "";
			$this->HotelID->TooltipValue = "";

			// RollNo
			$this->RollNo->LinkCustomAttributes = "";
			$this->RollNo->HrefValue = "";
			$this->RollNo->TooltipValue = "";

			// Name
			$this->Name->LinkCustomAttributes = "";
			$this->Name->HrefValue = "";
			$this->Name->TooltipValue = "";

			// Hostel
			$this->Hostel->LinkCustomAttributes = "";
			$this->Hostel->HrefValue = "";
			$this->Hostel->TooltipValue = "";

			// Floor
			$this->Floor->LinkCustomAttributes = "";
			$this->Floor->HrefValue = "";
			$this->Floor->TooltipValue = "";

			// Room_No
			$this->Room_No->LinkCustomAttributes = "";
			$this->Room_No->HrefValue = "";
			$this->Room_No->TooltipValue = "";

			// Health_issue
			$this->Health_issue->LinkCustomAttributes = "";
			$this->Health_issue->HrefValue = "";
			$this->Health_issue->TooltipValue = "";

			// Indiscipline_activity
			$this->Indiscipline_activity->LinkCustomAttributes = "";
			$this->Indiscipline_activity->HrefValue = "";
			$this->Indiscipline_activity->TooltipValue = "";

			// Involvement
			$this->Involvement->LinkCustomAttributes = "";
			$this->Involvement->HrefValue = "";
			$this->Involvement->TooltipValue = "";

			// Remarks
			$this->Remarks->LinkCustomAttributes = "";
			$this->Remarks->HrefValue = "";
			$this->Remarks->TooltipValue = "";

			// Others
			$this->Others->LinkCustomAttributes = "";
			$this->Others->HrefValue = "";
			$this->Others->TooltipValue = "";

			// Updatedby
			$this->Updatedby->LinkCustomAttributes = "";
			$this->Updatedby->HrefValue = "";
			$this->Updatedby->TooltipValue = "";

			// Updated_Date
			$this->Updated_Date->LinkCustomAttributes = "";
			$this->Updated_Date->HrefValue = "";
			$this->Updated_Date->TooltipValue = "";
		} elseif ($this->RowType == ROWTYPE_EDIT) { // Edit row

			// id
			$this->id->EditAttrs["class"] = "form-control";
			$this->id->EditCustomAttributes = "";
			$this->id->EditValue = $this->id->CurrentValue;
			$this->id->ViewCustomAttributes = "";

			// HotelID
			$this->HotelID->EditAttrs["class"] = "form-control";
			$this->HotelID->EditCustomAttributes = "";
			if ($this->HotelID->getSessionValue() != "") {
				$this->HotelID->CurrentValue = $this->HotelID->getSessionValue();
				$this->HotelID->ViewValue = $this->HotelID->CurrentValue;
				$this->HotelID->ViewCustomAttributes = "";
			} else {
				if (!$this->HotelID->Raw)
					$this->HotelID->CurrentValue = HtmlDecode($this->HotelID->CurrentValue);
				$this->HotelID->EditValue = HtmlEncode($this->HotelID->CurrentValue);
				$this->HotelID->PlaceHolder = RemoveHtml($this->HotelID->caption());
			}

			// RollNo
			$this->RollNo->EditAttrs["class"] = "form-control";
			$this->RollNo->EditCustomAttributes = "";
			if ($this->RollNo->getSessionValue() != "") {
				$this->RollNo->CurrentValue = $this->RollNo->getSessionValue();
				$this->RollNo->ViewValue = $this->RollNo->CurrentValue;
				$this->RollNo->ViewCustomAttributes = "";
			} else {
				if (!$this->RollNo->Raw)
					$this->RollNo->CurrentValue = HtmlDecode($this->RollNo->CurrentValue);
				$this->RollNo->EditValue = HtmlEncode($this->RollNo->CurrentValue);
				$this->RollNo->PlaceHolder = RemoveHtml($this->RollNo->caption());
			}

			// Name
			$this->Name->EditAttrs["class"] = "form-control";
			$this->Name->EditCustomAttributes = "";
			if ($this->Name->getSessionValue() != "") {
				$this->Name->CurrentValue = $this->Name->getSessionValue();
				$this->Name->ViewValue = $this->Name->CurrentValue;
				$this->Name->ViewCustomAttributes = "";
			} else {
				if (!$this->Name->Raw)
					$this->Name->CurrentValue = HtmlDecode($this->Name->CurrentValue);
				$this->Name->EditValue = HtmlEncode($this->Name->CurrentValue);
				$this->Name->PlaceHolder = RemoveHtml($this->Name->caption());
			}

			// Hostel
			$this->Hostel->EditAttrs["class"] = "form-control";
			$this->Hostel->EditCustomAttributes = "";
			if ($this->Hostel->getSessionValue() != "") {
				$this->Hostel->CurrentValue = $this->Hostel->getSessionValue();
				$curVal = strval($this->Hostel->CurrentValue);
				if ($curVal != "") {
					$this->Hostel->ViewValue = $this->Hostel->lookupCacheOption($curVal);
					if ($this->Hostel->ViewValue === NULL) { // Lookup from database
						$filterWrk = "`id`" . SearchString("=", $curVal, DATATYPE_NUMBER, "");
						$sqlWrk = $this->Hostel->Lookup->getSql(FALSE, $filterWrk, '', $this);
						$rswrk = Conn()->execute($sqlWrk);
						if ($rswrk && !$rswrk->EOF) { // Lookup values found
							$arwrk = [];
							$arwrk[1] = $rswrk->fields('df');
							$this->Hostel->ViewValue = $this->Hostel->displayValue($arwrk);
							$rswrk->Close();
						} else {
							$this->Hostel->ViewValue = $this->Hostel->CurrentValue;
						}
					}
				} else {
					$this->Hostel->ViewValue = NULL;
				}
				$this->Hostel->ViewCustomAttributes = "";
			} else {
				$curVal = trim(strval($this->Hostel->CurrentValue));
				if ($curVal != "")
					$this->Hostel->ViewValue = $this->Hostel->lookupCacheOption($curVal);
				else
					$this->Hostel->ViewValue = $this->Hostel->Lookup !== NULL && is_array($this->Hostel->Lookup->Options) ? $curVal : NULL;
				if ($this->Hostel->ViewValue !== NULL) { // Load from cache
					$this->Hostel->EditValue = array_values($this->Hostel->Lookup->Options);
				} else { // Lookup from database
					if ($curVal == "") {
						$filterWrk = "0=1";
					} else {
						$filterWrk = "`id`" . SearchString("=", $this->Hostel->CurrentValue, DATATYPE_NUMBER, "");
					}
					$sqlWrk = $this->Hostel->Lookup->getSql(TRUE, $filterWrk, '', $this);
					$rswrk = Conn()->execute($sqlWrk);
					$arwrk = $rswrk ? $rswrk->getRows() : [];
					if ($rswrk)
						$rswrk->close();
					$this->Hostel->EditValue = $arwrk;
				}
			}

			// Floor
			$this->Floor->EditAttrs["class"] = "form-control";
			$this->Floor->EditCustomAttributes = "";
			if ($this->Floor->getSessionValue() != "") {
				$this->Floor->CurrentValue = $this->Floor->getSessionValue();
				$curVal = strval($this->Floor->CurrentValue);
				if ($curVal != "") {
					$this->Floor->ViewValue = $this->Floor->lookupCacheOption($curVal);
					if ($this->Floor->ViewValue === NULL) { // Lookup from database
						$filterWrk = "`id`" . SearchString("=", $curVal, DATATYPE_NUMBER, "");
						$sqlWrk = $this->Floor->Lookup->getSql(FALSE, $filterWrk, '', $this);
						$rswrk = Conn()->execute($sqlWrk);
						if ($rswrk && !$rswrk->EOF) { // Lookup values found
							$arwrk = [];
							$arwrk[1] = $rswrk->fields('df');
							$this->Floor->ViewValue = $this->Floor->displayValue($arwrk);
							$rswrk->Close();
						} else {
							$this->Floor->ViewValue = $this->Floor->CurrentValue;
						}
					}
				} else {
					$this->Floor->ViewValue = NULL;
				}
				$this->Floor->ViewCustomAttributes = "";
			} else {
				$curVal = trim(strval($this->Floor->CurrentValue));
				if ($curVal != "")
					$this->Floor->ViewValue = $this->Floor->lookupCacheOption($curVal);
				else
					$this->Floor->ViewValue = $this->Floor->Lookup !== NULL && is_array($this->Floor->Lookup->Options) ? $curVal : NULL;
				if ($this->Floor->ViewValue !== NULL) { // Load from cache
					$this->Floor->EditValue = array_values($this->Floor->Lookup->Options);
				} else { // Lookup from database
					if ($curVal == "") {
						$filterWrk = "0=1";
					} else {
						$filterWrk = "`id`" . SearchString("=", $this->Floor->CurrentValue, DATATYPE_NUMBER, "");
					}
					$sqlWrk = $this->Floor->Lookup->getSql(TRUE, $filterWrk, '', $this);
					$rswrk = Conn()->execute($sqlWrk);
					$arwrk = $rswrk ? $rswrk->getRows() : [];
					if ($rswrk)
						$rswrk->close();
					$this->Floor->EditValue = $arwrk;
				}
			}

			// Room_No
			$this->Room_No->EditAttrs["class"] = "form-control";
			$this->Room_No->EditCustomAttributes = "";
			if ($this->Room_No->getSessionValue() != "") {
				$this->Room_No->CurrentValue = $this->Room_No->getSessionValue();
				$curVal = strval($this->Room_No->CurrentValue);
				if ($curVal != "") {
					$this->Room_No->ViewValue = $this->Room_No->lookupCacheOption($curVal);
					if ($this->Room_No->ViewValue === NULL) { // Lookup from database
						$filterWrk = "`Room_No`" . SearchString("=", $curVal, DATATYPE_NUMBER, "");
						$sqlWrk = $this->Room_No->Lookup->getSql(FALSE, $filterWrk, '', $this);
						$rswrk = Conn()->execute($sqlWrk);
						if ($rswrk && !$rswrk->EOF) { // Lookup values found
							$arwrk = [];
							$arwrk[1] = FormatNumber($rswrk->fields('df'), 0, -2, -2, -2);
							$this->Room_No->ViewValue = $this->Room_No->displayValue($arwrk);
							$rswrk->Close();
						} else {
							$this->Room_No->ViewValue = $this->Room_No->CurrentValue;
						}
					}
				} else {
					$this->Room_No->ViewValue = NULL;
				}
				$this->Room_No->ViewCustomAttributes = "";
			} else {
				$curVal = trim(strval($this->Room_No->CurrentValue));
				if ($curVal != "")
					$this->Room_No->ViewValue = $this->Room_No->lookupCacheOption($curVal);
				else
					$this->Room_No->ViewValue = $this->Room_No->Lookup !== NULL && is_array($this->Room_No->Lookup->Options) ? $curVal : NULL;
				if ($this->Room_No->ViewValue !== NULL) { // Load from cache
					$this->Room_No->EditValue = array_values($this->Room_No->Lookup->Options);
				} else { // Lookup from database
					if ($curVal == "") {
						$filterWrk = "0=1";
					} else {
						$filterWrk = "`Room_No`" . SearchString("=", $this->Room_No->CurrentValue, DATATYPE_NUMBER, "");
					}
					$sqlWrk = $this->Room_No->Lookup->getSql(TRUE, $filterWrk, '', $this);
					$rswrk = Conn()->execute($sqlWrk);
					$arwrk = $rswrk ? $rswrk->getRows() : [];
					if ($rswrk)
						$rswrk->close();
					$rowcnt = count($arwrk);
					for ($i = 0; $i < $rowcnt; $i++) {
						$arwrk[$i][1] = FormatNumber($arwrk[$i][1], 0, -2, -2, -2);
					}
					$this->Room_No->EditValue = $arwrk;
				}
			}

			// Health_issue
			$this->Health_issue->EditCustomAttributes = "";
			$curVal = trim(strval($this->Health_issue->CurrentValue));
			if ($curVal != "")
				$this->Health_issue->ViewValue = $this->Health_issue->lookupCacheOption($curVal);
			else
				$this->Health_issue->ViewValue = $this->Health_issue->Lookup !== NULL && is_array($this->Health_issue->Lookup->Options) ? $curVal : NULL;
			if ($this->Health_issue->ViewValue !== NULL) { // Load from cache
				$this->Health_issue->EditValue = array_values($this->Health_issue->Lookup->Options);
				if ($this->Health_issue->ViewValue == "")
					$this->Health_issue->ViewValue = $Language->phrase("PleaseSelect");
			} else { // Lookup from database
				if ($curVal == "") {
					$filterWrk = "0=1";
				} else {
					$arwrk = explode(",", $curVal);
					$filterWrk = "";
					foreach ($arwrk as $wrk) {
						if ($filterWrk != "")
							$filterWrk .= " OR ";
						$filterWrk .= "`Health_Issue`" . SearchString("=", trim($wrk), DATATYPE_STRING, "");
					}
				}
				$lookupFilter = function() {
					return "`Status`='1'";
				};
				$lookupFilter = $lookupFilter->bindTo($this);
				$sqlWrk = $this->Health_issue->Lookup->getSql(TRUE, $filterWrk, $lookupFilter, $this);
				$rswrk = Conn()->execute($sqlWrk);
				if ($rswrk && !$rswrk->EOF) { // Lookup values found
					$this->Health_issue->ViewValue = new OptionValues();
					$ari = 0;
					while (!$rswrk->EOF) {
						$arwrk = [];
						$arwrk[1] = HtmlEncode($rswrk->fields('df'));
						$this->Health_issue->ViewValue->add($this->Health_issue->displayValue($arwrk));
						$rswrk->MoveNext();
						$ari++;
					}
					$rswrk->MoveFirst();
				} else {
					$this->Health_issue->ViewValue = $Language->phrase("PleaseSelect");
				}
				$arwrk = $rswrk ? $rswrk->getRows() : [];
				if ($rswrk)
					$rswrk->close();
				$this->Health_issue->EditValue = $arwrk;
			}

			// Indiscipline_activity
			$this->Indiscipline_activity->EditCustomAttributes = "";
			if ($this->Indiscipline_activity->getSessionValue() != "") {
				$this->Indiscipline_activity->CurrentValue = $this->Indiscipline_activity->getSessionValue();
				$curVal = strval($this->Indiscipline_activity->CurrentValue);
				if ($curVal != "") {
					$this->Indiscipline_activity->ViewValue = $this->Indiscipline_activity->lookupCacheOption($curVal);
					if ($this->Indiscipline_activity->ViewValue === NULL) { // Lookup from database
						$arwrk = explode(",", $curVal);
						$filterWrk = "";
						foreach ($arwrk as $wrk) {
							if ($filterWrk != "")
								$filterWrk .= " OR ";
							$filterWrk .= "`id`" . SearchString("=", trim($wrk), DATATYPE_NUMBER, "");
						}
						$lookupFilter = function() {
							return "`Status`='1'";
						};
						$lookupFilter = $lookupFilter->bindTo($this);
						$sqlWrk = $this->Indiscipline_activity->Lookup->getSql(FALSE, $filterWrk, $lookupFilter, $this);
						$rswrk = Conn()->execute($sqlWrk);
						if ($rswrk && !$rswrk->EOF) { // Lookup values found
							$this->Indiscipline_activity->ViewValue = new OptionValues();
							$ari = 0;
							while (!$rswrk->EOF) {
								$arwrk = [];
								$arwrk[1] = $rswrk->fields('df');
								$this->Indiscipline_activity->ViewValue->add($this->Indiscipline_activity->displayValue($arwrk));
								$rswrk->MoveNext();
								$ari++;
							}
							$rswrk->Close();
						} else {
							$this->Indiscipline_activity->ViewValue = $this->Indiscipline_activity->CurrentValue;
						}
					}
				} else {
					$this->Indiscipline_activity->ViewValue = NULL;
				}
				$this->Indiscipline_activity->ViewCustomAttributes = "";
			} else {
				$curVal = trim(strval($this->Indiscipline_activity->CurrentValue));
				if ($curVal != "")
					$this->Indiscipline_activity->ViewValue = $this->Indiscipline_activity->lookupCacheOption($curVal);
				else
					$this->Indiscipline_activity->ViewValue = $this->Indiscipline_activity->Lookup !== NULL && is_array($this->Indiscipline_activity->Lookup->Options) ? $curVal : NULL;
				if ($this->Indiscipline_activity->ViewValue !== NULL) { // Load from cache
					$this->Indiscipline_activity->EditValue = array_values($this->Indiscipline_activity->Lookup->Options);
					if ($this->Indiscipline_activity->ViewValue == "")
						$this->Indiscipline_activity->ViewValue = $Language->phrase("PleaseSelect");
				} else { // Lookup from database
					if ($curVal == "") {
						$filterWrk = "0=1";
					} else {
						$arwrk = explode(",", $curVal);
						$filterWrk = "";
						foreach ($arwrk as $wrk) {
							if ($filterWrk != "")
								$filterWrk .= " OR ";
							$filterWrk .= "`id`" . SearchString("=", trim($wrk), DATATYPE_NUMBER, "");
						}
					}
					$lookupFilter = function() {
						return "`Status`='1'";
					};
					$lookupFilter = $lookupFilter->bindTo($this);
					$sqlWrk = $this->Indiscipline_activity->Lookup->getSql(TRUE, $filterWrk, $lookupFilter, $this);
					$rswrk = Conn()->execute($sqlWrk);
					if ($rswrk && !$rswrk->EOF) { // Lookup values found
						$this->Indiscipline_activity->ViewValue = new OptionValues();
						$ari = 0;
						while (!$rswrk->EOF) {
							$arwrk = [];
							$arwrk[1] = HtmlEncode($rswrk->fields('df'));
							$this->Indiscipline_activity->ViewValue->add($this->Indiscipline_activity->displayValue($arwrk));
							$rswrk->MoveNext();
							$ari++;
						}
						$rswrk->MoveFirst();
					} else {
						$this->Indiscipline_activity->ViewValue = $Language->phrase("PleaseSelect");
					}
					$arwrk = $rswrk ? $rswrk->getRows() : [];
					if ($rswrk)
						$rswrk->close();
					$this->Indiscipline_activity->EditValue = $arwrk;
				}
			}

			// Involvement
			$this->Involvement->EditAttrs["class"] = "form-control";
			$this->Involvement->EditCustomAttributes = "";
			$curVal = trim(strval($this->Involvement->CurrentValue));
			if ($curVal != "")
				$this->Involvement->ViewValue = $this->Involvement->lookupCacheOption($curVal);
			else
				$this->Involvement->ViewValue = $this->Involvement->Lookup !== NULL && is_array($this->Involvement->Lookup->Options) ? $curVal : NULL;
			if ($this->Involvement->ViewValue !== NULL) { // Load from cache
				$this->Involvement->EditValue = array_values($this->Involvement->Lookup->Options);
			} else { // Lookup from database
				if ($curVal == "") {
					$filterWrk = "0=1";
				} else {
					$filterWrk = "`id`" . SearchString("=", $this->Involvement->CurrentValue, DATATYPE_NUMBER, "");
				}
				$lookupFilter = function() {
					return "`Status`='1'";
				};
				$lookupFilter = $lookupFilter->bindTo($this);
				$sqlWrk = $this->Involvement->Lookup->getSql(TRUE, $filterWrk, $lookupFilter, $this);
				$rswrk = Conn()->execute($sqlWrk);
				$arwrk = $rswrk ? $rswrk->getRows() : [];
				if ($rswrk)
					$rswrk->close();
				$this->Involvement->EditValue = $arwrk;
			}

			// Remarks
			$this->Remarks->EditAttrs["class"] = "form-control";
			$this->Remarks->EditCustomAttributes = "";
			if (!$this->Remarks->Raw)
				$this->Remarks->CurrentValue = HtmlDecode($this->Remarks->CurrentValue);
			$this->Remarks->EditValue = HtmlEncode($this->Remarks->CurrentValue);
			$this->Remarks->PlaceHolder = RemoveHtml($this->Remarks->caption());

			// Others
			$this->Others->EditAttrs["class"] = "form-control";
			$this->Others->EditCustomAttributes = "";
			if (!$this->Others->Raw)
				$this->Others->CurrentValue = HtmlDecode($this->Others->CurrentValue);
			$this->Others->EditValue = HtmlEncode($this->Others->CurrentValue);
			$this->Others->PlaceHolder = RemoveHtml($this->Others->caption());

			// Updatedby
			// Updated_Date
			// Edit refer script
			// id

			$this->id->LinkCustomAttributes = "";
			$this->id->HrefValue = "";

			// HotelID
			$this->HotelID->LinkCustomAttributes = "";
			$this->HotelID->HrefValue = "";

			// RollNo
			$this->RollNo->LinkCustomAttributes = "";
			$this->RollNo->HrefValue = "";

			// Name
			$this->Name->LinkCustomAttributes = "";
			$this->Name->HrefValue = "";

			// Hostel
			$this->Hostel->LinkCustomAttributes = "";
			$this->Hostel->HrefValue = "";

			// Floor
			$this->Floor->LinkCustomAttributes = "";
			$this->Floor->HrefValue = "";

			// Room_No
			$this->Room_No->LinkCustomAttributes = "";
			$this->Room_No->HrefValue = "";

			// Health_issue
			$this->Health_issue->LinkCustomAttributes = "";
			$this->Health_issue->HrefValue = "";

			// Indiscipline_activity
			$this->Indiscipline_activity->LinkCustomAttributes = "";
			$this->Indiscipline_activity->HrefValue = "";

			// Involvement
			$this->Involvement->LinkCustomAttributes = "";
			$this->Involvement->HrefValue = "";

			// Remarks
			$this->Remarks->LinkCustomAttributes = "";
			$this->Remarks->HrefValue = "";

			// Others
			$this->Others->LinkCustomAttributes = "";
			$this->Others->HrefValue = "";

			// Updatedby
			$this->Updatedby->LinkCustomAttributes = "";
			$this->Updatedby->HrefValue = "";

			// Updated_Date
			$this->Updated_Date->LinkCustomAttributes = "";
			$this->Updated_Date->HrefValue = "";
		}
		if ($this->RowType == ROWTYPE_ADD || $this->RowType == ROWTYPE_EDIT || $this->RowType == ROWTYPE_SEARCH) // Add/Edit/Search row
			$this->setupFieldTitles();

		// Call Row Rendered event
		if ($this->RowType != ROWTYPE_AGGREGATEINIT)
			$this->Row_Rendered();
	}

	// Validate form
	protected function validateForm()
	{
		global $Language, $FormError;

		// Initialize form error message
		$FormError = "";

		// Check if validation required
		if (!Config("SERVER_VALIDATE"))
			return ($FormError == "");
		if ($this->id->Required) {
			if (!$this->id->IsDetailKey && $this->id->FormValue != NULL && $this->id->FormValue == "") {
				AddMessage($FormError, str_replace("%s", $this->id->caption(), $this->id->RequiredErrorMessage));
			}
		}
		if ($this->HotelID->Required) {
			if (!$this->HotelID->IsDetailKey && $this->HotelID->FormValue != NULL && $this->HotelID->FormValue == "") {
				AddMessage($FormError, str_replace("%s", $this->HotelID->caption(), $this->HotelID->RequiredErrorMessage));
			}
		}
		if ($this->RollNo->Required) {
			if (!$this->RollNo->IsDetailKey && $this->RollNo->FormValue != NULL && $this->RollNo->FormValue == "") {
				AddMessage($FormError, str_replace("%s", $this->RollNo->caption(), $this->RollNo->RequiredErrorMessage));
			}
		}
		if ($this->Name->Required) {
			if (!$this->Name->IsDetailKey && $this->Name->FormValue != NULL && $this->Name->FormValue == "") {
				AddMessage($FormError, str_replace("%s", $this->Name->caption(), $this->Name->RequiredErrorMessage));
			}
		}
		if ($this->Hostel->Required) {
			if (!$this->Hostel->IsDetailKey && $this->Hostel->FormValue != NULL && $this->Hostel->FormValue == "") {
				AddMessage($FormError, str_replace("%s", $this->Hostel->caption(), $this->Hostel->RequiredErrorMessage));
			}
		}
		if ($this->Floor->Required) {
			if (!$this->Floor->IsDetailKey && $this->Floor->FormValue != NULL && $this->Floor->FormValue == "") {
				AddMessage($FormError, str_replace("%s", $this->Floor->caption(), $this->Floor->RequiredErrorMessage));
			}
		}
		if ($this->Room_No->Required) {
			if (!$this->Room_No->IsDetailKey && $this->Room_No->FormValue != NULL && $this->Room_No->FormValue == "") {
				AddMessage($FormError, str_replace("%s", $this->Room_No->caption(), $this->Room_No->RequiredErrorMessage));
			}
		}
		if ($this->Health_issue->Required) {
			if ($this->Health_issue->FormValue == "") {
				AddMessage($FormError, str_replace("%s", $this->Health_issue->caption(), $this->Health_issue->RequiredErrorMessage));
			}
		}
		if ($this->Indiscipline_activity->Required) {
			if ($this->Indiscipline_activity->FormValue == "") {
				AddMessage($FormError, str_replace("%s", $this->Indiscipline_activity->caption(), $this->Indiscipline_activity->RequiredErrorMessage));
			}
		}
		if ($this->Involvement->Required) {
			if (!$this->Involvement->IsDetailKey && $this->Involvement->FormValue != NULL && $this->Involvement->FormValue == "") {
				AddMessage($FormError, str_replace("%s", $this->Involvement->caption(), $this->Involvement->RequiredErrorMessage));
			}
		}
		if ($this->Remarks->Required) {
			if (!$this->Remarks->IsDetailKey && $this->Remarks->FormValue != NULL && $this->Remarks->FormValue == "") {
				AddMessage($FormError, str_replace("%s", $this->Remarks->caption(), $this->Remarks->RequiredErrorMessage));
			}
		}
		if (!CheckInteger($this->Remarks->FormValue)) {
			AddMessage($FormError, $this->Remarks->errorMessage());
		}
		if ($this->Others->Required) {
			if (!$this->Others->IsDetailKey && $this->Others->FormValue != NULL && $this->Others->FormValue == "") {
				AddMessage($FormError, str_replace("%s", $this->Others->caption(), $this->Others->RequiredErrorMessage));
			}
		}
		if ($this->Updatedby->Required) {
			if (!$this->Updatedby->IsDetailKey && $this->Updatedby->FormValue != NULL && $this->Updatedby->FormValue == "") {
				AddMessage($FormError, str_replace("%s", $this->Updatedby->caption(), $this->Updatedby->RequiredErrorMessage));
			}
		}
		if ($this->Updated_Date->Required) {
			if (!$this->Updated_Date->IsDetailKey && $this->Updated_Date->FormValue != NULL && $this->Updated_Date->FormValue == "") {
				AddMessage($FormError, str_replace("%s", $this->Updated_Date->caption(), $this->Updated_Date->RequiredErrorMessage));
			}
		}

		// Return validate result
		$validateForm = ($FormError == "");

		// Call Form_CustomValidate event
		$formCustomError = "";
		$validateForm = $validateForm && $this->Form_CustomValidate($formCustomError);
		if ($formCustomError != "") {
			AddMessage($FormError, $formCustomError);
		}
		return $validateForm;
	}

	// Update record based on key values
	protected function editRow()
	{
		global $Security, $Language;
		$oldKeyFilter = $this->getRecordFilter();
		$filter = $this->applyUserIDFilters($oldKeyFilter);
		$conn = $this->getConnection();
		$this->CurrentFilter = $filter;
		$sql = $this->getCurrentSql();
		$conn->raiseErrorFn = Config("ERROR_FUNC");
		$rs = $conn->execute($sql);
		$conn->raiseErrorFn = "";
		if ($rs === FALSE)
			return FALSE;
		if ($rs->EOF) {
			$this->setFailureMessage($Language->phrase("NoRecord")); // Set no record message
			$editRow = FALSE; // Update Failed
		} else {

			// Save old values
			$rsold = &$rs->fields;
			$this->loadDbValues($rsold);
			$rsnew = [];

			// HotelID
			$this->HotelID->setDbValueDef($rsnew, $this->HotelID->CurrentValue, "", $this->HotelID->ReadOnly);

			// RollNo
			$this->RollNo->setDbValueDef($rsnew, $this->RollNo->CurrentValue, "", $this->RollNo->ReadOnly);

			// Name
			$this->Name->setDbValueDef($rsnew, $this->Name->CurrentValue, "", $this->Name->ReadOnly);

			// Hostel
			$this->Hostel->setDbValueDef($rsnew, $this->Hostel->CurrentValue, 0, $this->Hostel->ReadOnly);

			// Floor
			$this->Floor->setDbValueDef($rsnew, $this->Floor->CurrentValue, 0, $this->Floor->ReadOnly);

			// Room_No
			$this->Room_No->setDbValueDef($rsnew, $this->Room_No->CurrentValue, 0, $this->Room_No->ReadOnly);

			// Health_issue
			$this->Health_issue->setDbValueDef($rsnew, $this->Health_issue->CurrentValue, NULL, $this->Health_issue->ReadOnly);

			// Indiscipline_activity
			$this->Indiscipline_activity->setDbValueDef($rsnew, $this->Indiscipline_activity->CurrentValue, NULL, $this->Indiscipline_activity->ReadOnly);

			// Involvement
			$this->Involvement->setDbValueDef($rsnew, $this->Involvement->CurrentValue, NULL, $this->Involvement->ReadOnly);

			// Remarks
			$this->Remarks->setDbValueDef($rsnew, $this->Remarks->CurrentValue, NULL, $this->Remarks->ReadOnly);

			// Others
			$this->Others->setDbValueDef($rsnew, $this->Others->CurrentValue, NULL, $this->Others->ReadOnly);

			// Updatedby
			$this->Updatedby->setDbValueDef($rsnew, CurrentUserName(), "");
			$rsnew['Updatedby'] = &$this->Updatedby->DbValue;

			// Updated_Date
			$this->Updated_Date->setDbValueDef($rsnew, CurrentDateTime(), CurrentDate());
			$rsnew['Updated_Date'] = &$this->Updated_Date->DbValue;

			// Call Row Updating event
			$updateRow = $this->Row_Updating($rsold, $rsnew);

			// Check for duplicate key when key changed
			if ($updateRow) {
				$newKeyFilter = $this->getRecordFilter($rsnew); 
				if ($newKeyFilter != $oldKeyFilter) {
					$rsChk = $this->loadRs($newKeyFilter);
					if ($rsChk && !$rsChk->EOF) {
						$keyErrMsg = str_replace("%f", $newKeyFilter, $Language->phrase("DupKey"));
						$this->setFailureMessage($keyErrMsg);
						$rsChk->close();
						$updateRow = FALSE;
					}
				}
			}
			if ($updateRow) {
				$conn->raiseErrorFn = Config("ERROR_FUNC");
				if (count($rsnew) > 0)
					$editRow = $this->update($rsnew, "", $rsold);
				else
					$editRow = TRUE; // No field to update
				$conn->raiseErrorFn = "";
				if ($editRow) {
				}
			} else {
				if ($this->getSuccessMessage() != "" || $this->getFailureMessage() != "") {

					// Use the message, do nothing
				} elseif ($this->CancelMessage != "") {
					$this->setFailureMessage($this->CancelMessage);
					$this->CancelMessage = "";
				} else {
					$this->setFailureMessage($Language->phrase("UpdateCancelled"));
				}
				$editRow = FALSE;
			}
		}

		// Call Row_Updated event
		if ($editRow)
			$this->Row_Updated($rsold, $rsnew);
		$rs->close();

		// Write JSON for API request
		if (IsApi() && $editRow) {
			$row = $this->getRecordsFromRecordset([$rsnew], TRUE);
			WriteJson(["success" => TRUE, $this->TableVar => $row]);
		}
		return $editRow;
	}

	// Set up master/detail based on QueryString
	protected function setupMasterParms()
	{
		$validMaster = FALSE;

		// Get the keys for master table
		if (Get(Config("TABLE_SHOW_MASTER")) !== NULL) {
			$masterTblVar = Get(Config("TABLE_SHOW_MASTER"));
			if ($masterTblVar == "") {
				$validMaster = TRUE;
				$this->DbMasterFilter = "";
				$this->DbDetailFilter = "";
			}
			if ($masterTblVar == "admission") {
				$validMaster = TRUE;
				if (Get("fk_HostelID") !== NULL) {
					$GLOBALS["admission"]->HostelID->setQueryStringValue(Get("fk_HostelID"));
					$this->HotelID->setQueryStringValue($GLOBALS["admission"]->HostelID->QueryStringValue);
					$this->HotelID->setSessionValue($this->HotelID->QueryStringValue);
					if (!is_numeric($GLOBALS["admission"]->HostelID->QueryStringValue))
						$validMaster = FALSE;
				} else {
					$validMaster = FALSE;
				}
				if (Get("fk_RollNo") !== NULL) {
					$GLOBALS["admission"]->RollNo->setQueryStringValue(Get("fk_RollNo"));
					$this->RollNo->setQueryStringValue($GLOBALS["admission"]->RollNo->QueryStringValue);
					$this->RollNo->setSessionValue($this->RollNo->QueryStringValue);
				} else {
					$validMaster = FALSE;
				}
				if (Get("fk_Name") !== NULL) {
					$GLOBALS["admission"]->Name->setQueryStringValue(Get("fk_Name"));
					$this->Name->setQueryStringValue($GLOBALS["admission"]->Name->QueryStringValue);
					$this->Name->setSessionValue($this->Name->QueryStringValue);
				} else {
					$validMaster = FALSE;
				}
				if (Get("fk_Hostel") !== NULL) {
					$GLOBALS["admission"]->Hostel->setQueryStringValue(Get("fk_Hostel"));
					$this->Hostel->setQueryStringValue($GLOBALS["admission"]->Hostel->QueryStringValue);
					$this->Hostel->setSessionValue($this->Hostel->QueryStringValue);
					if (!is_numeric($GLOBALS["admission"]->Hostel->QueryStringValue))
						$validMaster = FALSE;
				} else {
					$validMaster = FALSE;
				}
				if (Get("fk_Floor") !== NULL) {
					$GLOBALS["admission"]->Floor->setQueryStringValue(Get("fk_Floor"));
					$this->Floor->setQueryStringValue($GLOBALS["admission"]->Floor->QueryStringValue);
					$this->Floor->setSessionValue($this->Floor->QueryStringValue);
					if (!is_numeric($GLOBALS["admission"]->Floor->QueryStringValue))
						$validMaster = FALSE;
				} else {
					$validMaster = FALSE;
				}
				if (Get("fk_RoomNo") !== NULL) {
					$GLOBALS["admission"]->RoomNo->setQueryStringValue(Get("fk_RoomNo"));
					$this->Room_No->setQueryStringValue($GLOBALS["admission"]->RoomNo->QueryStringValue);
					$this->Room_No->setSessionValue($this->Room_No->QueryStringValue);
					if (!is_numeric($GLOBALS["admission"]->RoomNo->QueryStringValue))
						$validMaster = FALSE;
				} else {
					$validMaster = FALSE;
				}
			}
			if ($masterTblVar == "indiscipline") {
				$validMaster = TRUE;
				if (Get("fk_id") !== NULL) {
					$GLOBALS["indiscipline"]->id->setQueryStringValue(Get("fk_id"));
					$this->Indiscipline_activity->setQueryStringValue($GLOBALS["indiscipline"]->id->QueryStringValue);
					$this->Indiscipline_activity->setSessionValue($this->Indiscipline_activity->QueryStringValue);
					if (!is_numeric($GLOBALS["indiscipline"]->id->QueryStringValue))
						$validMaster = FALSE;
				} else {
					$validMaster = FALSE;
				}
			}
		} elseif (Post(Config("TABLE_SHOW_MASTER")) !== NULL) {
			$masterTblVar = Post(Config("TABLE_SHOW_MASTER"));
			if ($masterTblVar == "") {
				$validMaster = TRUE;
				$this->DbMasterFilter = "";
				$this->DbDetailFilter = "";
			}
			if ($masterTblVar == "admission") {
				$validMaster = TRUE;
				if (Post("fk_HostelID") !== NULL) {
					$GLOBALS["admission"]->HostelID->setFormValue(Post("fk_HostelID"));
					$this->HotelID->setFormValue($GLOBALS["admission"]->HostelID->FormValue);
					$this->HotelID->setSessionValue($this->HotelID->FormValue);
					if (!is_numeric($GLOBALS["admission"]->HostelID->FormValue))
						$validMaster = FALSE;
				} else {
					$validMaster = FALSE;
				}
				if (Post("fk_RollNo") !== NULL) {
					$GLOBALS["admission"]->RollNo->setFormValue(Post("fk_RollNo"));
					$this->RollNo->setFormValue($GLOBALS["admission"]->RollNo->FormValue);
					$this->RollNo->setSessionValue($this->RollNo->FormValue);
				} else {
					$validMaster = FALSE;
				}
				if (Post("fk_Name") !== NULL) {
					$GLOBALS["admission"]->Name->setFormValue(Post("fk_Name"));
					$this->Name->setFormValue($GLOBALS["admission"]->Name->FormValue);
					$this->Name->setSessionValue($this->Name->FormValue);
				} else {
					$validMaster = FALSE;
				}
				if (Post("fk_Hostel") !== NULL) {
					$GLOBALS["admission"]->Hostel->setFormValue(Post("fk_Hostel"));
					$this->Hostel->setFormValue($GLOBALS["admission"]->Hostel->FormValue);
					$this->Hostel->setSessionValue($this->Hostel->FormValue);
					if (!is_numeric($GLOBALS["admission"]->Hostel->FormValue))
						$validMaster = FALSE;
				} else {
					$validMaster = FALSE;
				}
				if (Post("fk_Floor") !== NULL) {
					$GLOBALS["admission"]->Floor->setFormValue(Post("fk_Floor"));
					$this->Floor->setFormValue($GLOBALS["admission"]->Floor->FormValue);
					$this->Floor->setSessionValue($this->Floor->FormValue);
					if (!is_numeric($GLOBALS["admission"]->Floor->FormValue))
						$validMaster = FALSE;
				} else {
					$validMaster = FALSE;
				}
				if (Post("fk_RoomNo") !== NULL) {
					$GLOBALS["admission"]->RoomNo->setFormValue(Post("fk_RoomNo"));
					$this->Room_No->setFormValue($GLOBALS["admission"]->RoomNo->FormValue);
					$this->Room_No->setSessionValue($this->Room_No->FormValue);
					if (!is_numeric($GLOBALS["admission"]->RoomNo->FormValue))
						$validMaster = FALSE;
				} else {
					$validMaster = FALSE;
				}
			}
			if ($masterTblVar == "indiscipline") {
				$validMaster = TRUE;
				if (Post("fk_id") !== NULL) {
					$GLOBALS["indiscipline"]->id->setFormValue(Post("fk_id"));
					$this->Indiscipline_activity->setFormValue($GLOBALS["indiscipline"]->id->FormValue);
					$this->Indiscipline_activity->setSessionValue($this->Indiscipline_activity->FormValue);
					if (!is_numeric($GLOBALS["indiscipline"]->id->FormValue))
						$validMaster = FALSE;
				} else {
					$validMaster = FALSE;
				}
			}
		}
		if ($validMaster) {

			// Save current master table
			$this->setCurrentMasterTable($masterTblVar);
			$this->setSessionWhere($this->getDetailFilter());

			// Reset start record counter (new master key)
			if (!$this->isAddOrEdit()) {
				$this->StartRecord = 1;
				$this->setStartRecordNumber($this->StartRecord);
			}

			// Clear previous master key from Session
			if ($masterTblVar != "admission") {
				if ($this->HotelID->CurrentValue == "")
					$this->HotelID->setSessionValue("");
				if ($this->RollNo->CurrentValue == "")
					$this->RollNo->setSessionValue("");
				if ($this->Name->CurrentValue == "")
					$this->Name->setSessionValue("");
				if ($this->Hostel->CurrentValue == "")
					$this->Hostel->setSessionValue("");
				if ($this->Floor->CurrentValue == "")
					$this->Floor->setSessionValue("");
				if ($this->Room_No->CurrentValue == "")
					$this->Room_No->setSessionValue("");
			}
			if ($masterTblVar != "indiscipline") {
				if ($this->Indiscipline_activity->CurrentValue == "")
					$this->Indiscipline_activity->setSessionValue("");
			}
		}
		$this->DbMasterFilter = $this->getMasterFilter(); // Get master filter
		$this->DbDetailFilter = $this->getDetailFilter(); // Get detail filter
	}

	// Set up Breadcrumb
	protected function setupBreadcrumb()
	{
		global $Breadcrumb, $Language;
		$Breadcrumb = new Breadcrumb();
		$url = substr(CurrentUrl(), strrpos(CurrentUrl(), "/")+1);
		$Breadcrumb->add("list", $this->TableVar, $this->addMasterUrl("activitylist.php"), "", $this->TableVar, TRUE);
		$pageId = "edit";
		$Breadcrumb->add("edit", $pageId, $url);
	}

	// Setup lookup options
	public function setupLookupOptions($fld)
	{
		if ($fld->Lookup !== NULL && $fld->Lookup->Options === NULL) {

			// Get default connection and filter
			$conn = $this->getConnection();
			$lookupFilter = "";

			// No need to check any more
			$fld->Lookup->Options = [];

			// Set up lookup SQL and connection
			switch ($fld->FieldVar) {
				case "x_Hostel":
					$conn = Conn("");
					break;
				case "x_Floor":
					$conn = Conn("");
					break;
				case "x_Room_No":
					$conn = Conn("");
					break;
				case "x_Health_issue":
					$conn = Conn("");
					$lookupFilter = function() {
						return "`Status`='1'";
					};
					$lookupFilter = $lookupFilter->bindTo($this);
					break;
				case "x_Indiscipline_activity":
					$conn = Conn("");
					$lookupFilter = function() {
						return "`Status`='1'";
					};
					$lookupFilter = $lookupFilter->bindTo($this);
					break;
				case "x_Involvement":
					$conn = Conn("");
					$lookupFilter = function() {
						return "`Status`='1'";
					};
					$lookupFilter = $lookupFilter->bindTo($this);
					break;
				default:
					$lookupFilter = "";
					break;
			}

			// Always call to Lookup->getSql so that user can setup Lookup->Options in Lookup_Selecting server event
			$sql = $fld->Lookup->getSql(FALSE, "", $lookupFilter, $this);

			// Set up lookup cache
			if ($fld->UseLookupCache && $sql != "" && count($fld->Lookup->Options) == 0) {
				$totalCnt = $this->getRecordCount($sql, $conn);
				if ($totalCnt > $fld->LookupCacheCount) // Total count > cache count, do not cache
					return;
				$rs = $conn->execute($sql);
				$ar = [];
				while ($rs && !$rs->EOF) {
					$row = &$rs->fields;

					// Format the field values
					switch ($fld->FieldVar) {
						case "x_Hostel":
							break;
						case "x_Floor":
							break;
						case "x_Room_No":
							$row[1] = FormatNumber($row[1], 0, -2, -2, -2);
							$row['df'] = $row[1];
							break;
						case "x_Health_issue":
							break;
						case "x_Indiscipline_activity":
							break;
						case "x_Involvement":
							break;
					}
					$ar[strval($row[0])] = $row;
					$rs->moveNext();
				}
				if ($rs)
					$rs->close();
				$fld->Lookup->Options = $ar;
			}
		}
	}

	// Set up starting record parameters
	public function setupStartRecord()
	{
		if ($this->DisplayRecords == 0)
			return;
		if ($this->isPageRequest()) { // Validate request
			$startRec = Get(Config("TABLE_START_REC"));
			$pageNo = Get(Config("TABLE_PAGE_NO"));
			if ($startRec !== NULL) { // Check for "start" parameter
				$this->StartRecord = $startRec;
				$this->setStartRecordNumber($this->StartRecord);
			} elseif ($pageNo !== NULL) {
				if (is_numeric($pageNo)) {
					$this->StartRecord = ($pageNo - 1) * $this->DisplayRecords + 1;
					if ($this->StartRecord <= 0) {
						$this->StartRecord = 1;
					} elseif ($this->StartRecord >= (int)(($this->TotalRecords - 1)/$this->DisplayRecords) * $this->DisplayRecords + 1) {
						$this->StartRecord = (int)(($this->TotalRecords - 1)/$this->DisplayRecords) * $this->DisplayRecords + 1;
					}
					$this->setStartRecordNumber($this->StartRecord);
				}
			}
		}
		$this->StartRecord = $this->getStartRecordNumber();

		// Check if correct start record counter
		if (!is_numeric($this->StartRecord) || $this->StartRecord == "") { // Avoid invalid start record counter
			$this->StartRecord = 1; // Reset start record counter
			$this->setStartRecordNumber($this->StartRecord);
		} elseif ($this->StartRecord > $this->TotalRecords) { // Avoid starting record > total records
			$this->StartRecord = (int)(($this->TotalRecords - 1)/$this->DisplayRecords) * $this->DisplayRecords + 1; // Point to last page first record
			$this->setStartRecordNumber($this->StartRecord);
		} elseif (($this->StartRecord - 1) % $this->DisplayRecords != 0) {
			$this->StartRecord = (int)(($this->StartRecord - 1)/$this->DisplayRecords) * $this->DisplayRecords + 1; // Point to page boundary
			$this->setStartRecordNumber($this->StartRecord);
		}
	}

	// Page Load event
	function Page_Load() {

		//echo "Page Load";
	}

	// Page Unload event
	function Page_Unload() {

		//echo "Page Unload";
	}

	// Page Redirecting event
	function Page_Redirecting(&$url) {

		// Example:
		//$url = "your URL";

	}

	// Message Showing event
	// $type = ''|'success'|'failure'|'warning'
	function Message_Showing(&$msg, $type) {
		if ($type == 'success') {

			//$msg = "your success message";
		} elseif ($type == 'failure') {

			//$msg = "your failure message";
		} elseif ($type == 'warning') {

			//$msg = "your warning message";
		} else {

			//$msg = "your message";
		}
	}

	// Page Render event
	function Page_Render() {

		//echo "Page Render";
	}

	// Page Data Rendering event
	function Page_DataRendering(&$header) {

		// Example:
		//$header = "your header";

	}

	// Page Data Rendered event
	function Page_DataRendered(&$footer) {

		// Example:
		//$footer = "your footer";

	}

	// Form Custom Validate event
	function Form_CustomValidate(&$customError) {

		// Return error message in CustomError
		return TRUE;
	}
} // End class
?>